Summary: User-space implementation of L2TP (RFC 2661) for Linux
Name: rp-l2tp
Version: 0.4
Release: 2jdl
License: GPL
Group: System Environment/Daemons
Source: http://osdn.dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz
Source1: %{name}d.init
Source3: %{name}-RPM.README
# Minimal sample configuration file for use with Openswan
#Source4: %{name}-l2tpd.conf
Source5: %{name}-l2tp.conf
Source11: %{name}-chapsecrets.sample
# Sample Openswan configuration files
Source6: %{name}-L2TP-PSK.conf
Source7: %{name}-L2TP-CERT.conf
Source8: %{name}-L2TP-PSK-orgWIN2KXP.conf
Source9: %{name}-L2TP-CERT-orgWIN2KXP.conf
Url: http://sourceforge.net/projects/%{name}
BuildRoot: %{_tmppath}/%{name}-root
Prereq: /sbin/chkconfig /sbin/service fileutils 
Requires: ppp >= 2.3.13, kernel >= 2.4.0, initscripts >= 5.92
# Original packager: Alexandr D. Kanevskiy <kad@asplinux.ru>
Packager: Jacco de Leeuw <jacco2@dds.nl>
Vendor: David F. Skoll <dfs@roaringpenguin.com>

%define         freeswanconfigpath freeswan
%define         openswanconfigpath openswan
%define         strongswanconfigpath strongswan
%define         ipsecconfigpath ipsec.d

%description
rp-l2tp is an implementation of the Layer 2 Tunnelling Protocol (RFC 2661).
L2TP allows you to tunnel PPP over UDP. Some ISPs use L2TP to tunnel user
sessions from dial-in servers (modem banks, ADSL DSLAMs) to back-end PPP
servers. Another important application is Virtual Private Networks where
the IPsec protocol is used to secure the L2TP connection (L2TP/IPsec,
RFC 3193). The L2TP/IPsec protocol is mainly used by Windows and
MacOS X clients. On Linux, rp-l2tp can be used in combination with IPsec
implementations such as FreeS/WAN, Openswan, Strongswan and KAME.
Example configuration files for such a setup are included in this RPM.
rp-l2tp runs completely in userspace.

David Skoll of Roaring Penguin Software Inc. wrote rp-l2tp. This RPM is
based on the original rp-l2tp RPM by Alexandr D. Kanevskiy of ASPLinux.

%prep
%setup -q
cp -p %{SOURCE3} RPM.README

%build
%configure
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
make install RPM_INSTALL_ROOT=$RPM_BUILD_ROOT 

install -d ${RPM_BUILD_ROOT}%{_sysconfdir}/{%{name},ppp,%{ipsecconfigpath}}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/l2tpd
#install -m644 %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/%{name}.conf
install -m644 %{SOURCE5} ${RPM_BUILD_ROOT}%{_sysconfdir}/l2tp/l2tp.conf
install -m644 %{SOURCE6} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK.conf
install -m644 %{SOURCE7} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT.conf
install -m644 %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK-orgWIN2KXP.conf
install -m644 %{SOURCE9} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT-orgWIN2KXP.conf
install -m600 %{SOURCE11} ${RPM_BUILD_ROOT}%{_sysconfdir}/ppp/chap-secrets.sample

%clean
rm -rf $RPM_BUILD_ROOT

%post
# For security reasons rp-l2tp is not started when the RPM is installed
# or at a reboot. To start rp-l2tp manually, use:
#   /sbin/service rp-l2tp start
# To start l2tpd at a reboot, use:
#   /sbin/chkconfig --add l2tpd

# The Mandrake RPMs for Openswan, Strongswan and FreeS/WAN do not use
# /etc/ipsec.d/ for some reason. The symbolic links below are a workaround.
# (Probably should test for existence instead of forced creation after making
# a backup copy).
if [ -d %{_sysconfdir}/%{freeswanconfigpath} ]; then
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK.conf %{_sysconfdir}/%{freeswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT.conf %{_sysconfdir}/%{freeswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK-orgWIN2KXP.conf %{_sysconfdir}/%{freeswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT-orgWIN2KXP.conf %{_sysconfdir}/%{freeswanconfigpath}
fi
if [ -d %{_sysconfdir}/%{openswanconfigpath} ]; then
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK.conf %{_sysconfdir}/%{openswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT.conf %{_sysconfdir}/%{openswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK-orgWIN2KXP.conf %{_sysconfdir}/%{openswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT-orgWIN2KXP.conf %{_sysconfdir}/%{openswanconfigpath}
fi
if [ -d %{_sysconfdir}/%{strongswanconfigpath} ]; then
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK.conf %{_sysconfdir}/%{strongswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT.conf %{_sysconfdir}/%{strongswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-PSK-orgWIN2KXP.conf %{_sysconfdir}/%{strongswanconfigpath}
  ln -sfb %{_sysconfdir}/%{ipsecconfigpath}/L2TP-CERT-orgWIN2KXP.conf %{_sysconfdir}/%{strongswanconfigpath}
fi

%preun
if [ "$1" = 0 ] ; then
  service l2tpd stop >/dev/null 2>&1
  /sbin/chkconfig --del l2tpd
fi
    
%postun
if [ "$1" -ge "1" ]; then
  service l2tpd condrestart >/dev/null 2>&1
fi
  


%files
%defattr(-,root,root)
%doc README
%dir %{_sysconfdir}/l2tp
%config %{_sysconfdir}/l2tp/*
%config /etc/rc.d/init.d/l2tpd
%config(noreplace) %{_sysconfdir}/ppp/*
%dir %{_sysconfdir}/%{ipsecconfigpath}
%config(noreplace) %{_sysconfdir}/%{ipsecconfigpath}/*

%{_sbindir}/*
%{_libdir}/l2tp
%{_mandir}/man?/*

%changelog
* Wed Dec 23 2004 Jacco de Leeuw <jacco2@dds.nl> 0.4-2jdl
- "peer 0.0.0.0" does work, but only in combination with "mask 0".

* Wed Dec 12 2004 Jacco de Leeuw <jacco2@dds.nl> 0.4-1jdl
- Upgraded to version 0.4.
- Added Openswan configuration files.
- Use %{name} style where possible.

* Thu Oct 03 2002 Alexandr D. Kanevskiy <kad@asplinux.ru>
- add init script

* Thu Oct 03 2002 Alexandr D. Kanevskiy <kad@asplinux.ru>
- build for ASPLinux
